 procedure proizv(var c,a_,b:oper); var i,j,k:integer; {B(Ax+a)+b=(BA)x+(Ba+b)}
 begin
  for i:=1 to 3 do begin for k:=1 to 3 do begin
   c.a[i,k]:=0; for j:=1 to 3 do c.a[i,k]:=c.a[i,k]+b.a[i,j]*a_.a[j,k];
  end end;
  for i:=1 to 3 do begin
   c.tau[i]:=b.tau[i]; for j:=1 to 3 do c.tau[i]:=c.tau[i]+b.a[i,j]*a_.tau[j];
   if abs(c.tau[i]-round(c.tau[i]))<1.E-6 then c.tau[i]:=round(c.tau[i]);
   while c.tau[i]<0 do c.tau[i]:=c.tau[i]+1;
   if int(c.tau[i])>0 then c.tau[i]:=frac(c.tau[i]);
  end;
 end;

 procedure show_elt(ope:oper); var i,j:integer;
 begin
  with ope do begin
   for i:=1 to 3 do begin
    for j:=1 to 3 do write(a[i,j]:5:2); writeln(' ',tau[i]:5:2);
   end;
  end; writeln;
 end;

 procedure show_simm; var i,j,k:integer;
 begin
  for k:=1 to n_oper do begin writeln(k); with ope[k] do begin
   for i:=1 to 3 do begin
    for j:=1 to 3 do write(a[i,j]:5:2); writeln(' ',tau[i]:5:2);
   end;
  end; end;
  if n_centrir<>1 then for k:=1 to n_centrir do begin writeln('centr. - ',k);
   for i:=1 to 3 do write(centrir[k][i]:5:2); writeln;
  end;
 end;

{-------- trikl. --------}
{------ C1 ------}

 procedure P1; {polezna dl`a otladki}
 begin
  n_oper:=1;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

{------ Ci ------}

 procedure P1_; {primer - trikl. p-C6H4Cl2}
 begin
  n_oper:=2;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,-1); initvect(ope[2].tau, 0,0,0);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

{-------- monokl. --------}
{------ C2 ------}

 procedure P2;
 {predp., chto b perp. ac}
 begin
  n_oper:=2;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,1,0, 0,0,-1); initvect(ope[2].tau, 0,0,0);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure P2_1; {C_2^2; primer - L-triptofan*HCl}
 {predp., chto b perp. ac}
 begin
  P2; initvect(ope[2].tau, 0,1/2,0);
 end;

 procedure C2 {C2h^3};
 begin
  P2;
  n_centrir:=2;
  initvect(centrir[1], 0,0,0);
  initvect(centrir[2], 1/2,1/2,0);
 end;

{------ Cs ------}

 procedure P_c; {C_s^2}
 {predp., chto b perp. ac}
 begin
  n_oper:=2;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[2].tau, 0,0,1/2);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure C_c; {C_s^4}
 {predp., chto b perp. ac}
 begin
  n_oper:=2;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[2].tau, 0,0,1/2);
  n_centrir:=2;
  initvect(centrir[1], 0,0,0);
  initvect(centrir[2], 1/2,1/2,0);
 end;

 procedure A_a; {C_c v dr. ustan.}
 {predp., chto b perp. ac}
 begin
  n_oper:=2;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[2].tau, 1/2,0,0);
  n_centrir:=2;
  initvect(centrir[1], 0,0,0);
  initvect(centrir[2], 0,1/2,1/2);
 end;

{------ C2h ------}

 procedure P2_m; {C_2h^1}
 {predp., chto b perp. ac}
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,-1); initvect(ope[2].tau, 0,0,0);
  initmatr(ope[3].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[3].tau, 0,0,0);
  initmatr(ope[4].a, -1,0,0, 0,1,0, 0,0,-1); initvect(ope[4].tau, 0,0,0);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure P2_1_m; {C_2h^2}
 {predp., chto b perp. ac}
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,-1); initvect(ope[2].tau, 0,0,0);
  initmatr(ope[3].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[3].tau, 0,1/2,0);
  initmatr(ope[4].a, -1,0,0, 0,1,0, 0,0,-1); initvect(ope[4].tau, 0,1/2,0);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure C2_m; {C_2h^3}
 {predp., chto b perp. ac}
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,-1); initvect(ope[2].tau, 0,0,0);
  initmatr(ope[3].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[3].tau, 0,0,0);
  initmatr(ope[4].a, -1,0,0, 0,1,0, 0,0,-1); initvect(ope[4].tau, 0,0,0);
  n_centrir:=2;
  initvect(centrir[1], 0,0,0);
  initvect(centrir[2], 1/2,1/2,0);
 end;

 procedure P2_c; {C_2h^4}
 {predp., chto b perp. ac}
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,-1); initvect(ope[2].tau, 0,0,0);
  initmatr(ope[3].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[3].tau, 0,0,1/2);
  initmatr(ope[4].a, -1,0,0, 0,1,0, 0,0,-1); initvect(ope[4].tau, 0,0,1/2);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure P2_1_c; {C_2h^5; primer: gamma-KIO3.HIO3}
 {predp., chto b perp. ac}
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,-1); initvect(ope[2].tau, 0,0,0);
  initmatr(ope[3].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[3].tau, 0,1/2,1/2);
  initmatr(ope[4].a, -1,0,0, 0,1,0, 0,0,-1); initvect(ope[4].tau, 0,1/2,1/2);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure P2_1_a; {P2_1_c v drugoj ustanovke; primer - p-khinon}
 {predp., chto b perp. ac}
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,-1); initvect(ope[2].tau, 0,0,0);
  initmatr(ope[3].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[3].tau, 1/2,1/2,0);
  initmatr(ope[4].a, -1,0,0, 0,1,0, 0,0,-1); initvect(ope[4].tau, 1/2,1/2,0);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure P2_1_n; {P2_1_c v dr. ustan.; primer - S4N4}
 {predp., chto b perp. ac}
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,-1); initvect(ope[2].tau, 0,0,0);
  initmatr(ope[3].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[3].tau, 1/2,1/2,1/2);
  initmatr(ope[4].a, -1,0,0, 0,1,0, 0,0,-1); initvect(ope[4].tau, 1/2,1/2,1/2);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure B2_b; {C_2h^6}
 {C_2h^6 = B 1 1 2/b; c perp. ab;
   v dr. ust.: A112/a, C2/c11, B2/b11, C12/c1, A12/a1.
 }
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,-1); initvect(ope[2].tau, 0,0,0);
  initmatr(ope[3].a, 1,0,0, 0,1,0, 0,0,-1); initvect(ope[3].tau, 0,1/2,0);
  initmatr(ope[4].a, -1,0,0, 0,-1,0, 0,0,1); initvect(ope[4].tau, 0,1/2,0);
  n_centrir:=2;
  initvect(centrir[1], 0,0,0);
  initvect(centrir[2], 1/2,0,1/2);
 end;

 procedure C2_c; {C_2h^6 v dr. ust. = C 1 2/c 1; b perp. ac}
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,-1); initvect(ope[2].tau, 0,0,0);
  initmatr(ope[3].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[3].tau, 0,0,1/2);
  initmatr(ope[4].a, -1,0,0, 0,1,0, 0,0,-1); initvect(ope[4].tau, 0,0,1/2);
  n_centrir:=2;
  initvect(centrir[1], 0,0,0);
  initvect(centrir[2], 1/2,1/2,0);
 end;

{-------- ortorombich. --------}
{------ D2 -----}
 procedure P2_1_2_1_2_1; {D2^4} var a,b,c:real;
 begin
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
 {na primere a1..a3=0.1,0.2,0.3, b1..b3=0.001,0.02,0.03 poluch.:
   dl`a C2x tau=(a1,a2,a3), dl`a C2z tau=(b1,b2,b3) =>
   C2x*C2z -> tau=(-a1+b1, -a2+b2, a3+b3),
   C2z*C2x ->     ( a1+b1,  a2-b2, a3-b3).
   Raznosti = tselym chislam, napr., (a1+b1)-(-a1+b1) = 2*a1 =n
   => a1=n/2, b3=n/2, a2-b2=n/2.
   Zdes` n/2 = 0, +-1/2, +-1, ... .
   My khotim P 2_1 2_1 2_1, poetomu a1=1/2, b3=1/2, b2=1/2+a2.
   Poluch:
   C2x: tau= 1/2     a2     a3;
   C2y:     1/2+b1  1/2   1/2+a3;
   C2z:       b1   1/2+a2  1/2;
   Pereobozn.:
   C2x:      1/2      a    1/2+b
   C2y:     1/2+c    1/2     b
   C2z:       c     1/2+a   1/2
  Kak vybrano standartno - nejasno.
  Probuem dl`a L-alanina 4 var-ta: a=b=c=0, 1/4, 1/2, 3/4.
  Poluch.: 1/2 - prekrasn., proch. - shuin.
}
  a:=1/2; b:=1/2; c:=1/2;
  initmatr(ope[2].a,1,0,0, 0,-1,0, 0,0,-1); initvect(ope[2].tau,1/2,a,1/2+b);
  initmatr(ope[4].a,-1,0,0, 0,-1,0, 0,0,1); initvect(ope[4].tau,c,1/2+a,1/2);
  proizv(ope[3],ope[2],ope[4]);
 end;

{------ C2v -----}

 procedure C2cm; {CrO3; nestand. ustanovka?}
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, 1,0,0, 0,-1,0, 0,0,-1); initvect(ope[2].tau, 0,0,0);
  initmatr(ope[3].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[3].tau, 0,0,1/2);
  initmatr(ope[4].a, 1,0,0, 0,1,0, 0,0,-1); initvect(ope[4].tau, 0,0,1/2);
  n_centrir:=2;
  initvect(centrir[1], 0,0,0);
  initvect(centrir[2], 1/2,1/2,0);
 end;

 procedure Pc2_1n;
 {C2v^9 = Pna2_1 v dr. ustanovke (vozm. tzh. Pbn2_1); primer - NH4IO3;
  2_1 - po osi, pl-sti - v promezhutkakh.
 }
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,1,0, 0,0,-1); initvect(ope[2].tau, 0,1/2,0);
  initmatr(ope[3].a, -1,0,0, 0,1,0, 0,0,1); initvect(ope[3].tau, 1/2,0,1/2);
  initmatr(ope[4].a, 1,0,0, 0,1,0, 0,0,-1); initvect(ope[4].tau, 1/2,1/2,1/2);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure Fdd2; {C2v^19} {primer: delta-KIO3.HIO3}
 begin
  n_oper:=4;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,1); initvect(ope[2].tau, 0,0,0);
  initmatr(ope[3].a, -1,0,0, 0,1,0, 0,0,1); initvect(ope[3].tau, 1/4,1/4,1/4);
  initmatr(ope[4].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[4].tau, 1/4,1/4,1/4);
  n_centrir:=4;
  initvect(centrir[1], 0,0,0);
  initvect(centrir[2], 0,1/2,1/2);
  initvect(centrir[3], 1/2,0,1/2);
  initvect(centrir[4], 1/2,1/2,0);
 end;

{------ D2h -----}

 {rasstanovka chastichn. tr-tsij v gruppakh Pxxx: primer: Pmma:
   ispol`z., chto dl`a otr. v plosk., perp. x, chast. transl. po x zaranee
   ne opr., poetomu pishem d1; chast. transl. po y i z ustanavl. iz
   simvola pl-sti (m, b, c ili n; razumeetsa, v etoj pozits. nevozm. 'a');
   analog. po y i z.
   E          x       y       z
  m perp x    -x+d1   y       z
  m perp y    x      -y+d2    z
  a perp z    x+1/2   y     -z+d3
  Teper` ispol`z. peremnozh. el-tov, chtoby najti di (napr., mx*my*i=mz).
  V dann. sluch. vosst. oznozn.: d1=1/2. d2=0, d3=0. (Dl`a Pxxxx uslovie
  dl`a nakh. di mozhno sformul. v vide: v kazhd. stolbtse - ili ni odnoj 1/2,
  libo 2 shtuki '+1/2'.
 }

 procedure Pmmm;
 begin
  n_oper:=8;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, 1,0,0, 0,-1,0, 0,0,-1); initvect(ope[2].tau, 0,0,0);
  initmatr(ope[3].a, -1,0,0, 0,1,0, 0,0,-1); initvect(ope[3].tau, 0,0,0);
  initmatr(ope[4].a, -1,0,0, 0,-1,0, 0,0,1); initvect(ope[4].tau, 0,0,0);
  initmatr(ope[5].a, -1,0,0, 0,-1,0, 0,0,-1); initvect(ope[5].tau, 0,0,0);
  initmatr(ope[6].a, -1,0,0, 0,1,0, 0,0,1); initvect(ope[6].tau, 0,0,0);
  initmatr(ope[7].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[7].tau, 0,0,0);
  initmatr(ope[8].a, 1,0,0, 0,1,0, 0,0,-1); initvect(ope[8].tau, 0,0,0);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure Pbca {D_2h^15}; var a:real;
 {primer - H3N+-(CH2)2-CO2- ("beta-alanin")}
 {imenno a,a,0, 0,a,a, a,0,a,
   a ne naobor.(?), inache -> pravdop. upak., no rasst. otlich. ot tabulir.}
 begin a:=0.5;
  Pmmm;
  initvect(ope[1].tau, 0,0,0);
  initvect(ope[2].tau, a,a,0);
  initvect(ope[3].tau, 0,a,a);
  initvect(ope[4].tau, a,0,a);
  initvect(ope[5].tau, 0,0,0);
  initvect(ope[6].tau, a,a,0);
  initvect(ope[7].tau, 0,a,a);
  initvect(ope[8].tau, a,0,a);
 end;

 procedure Pnma {D_2h^16}; var a:real; {primer - NH4ClO4}
 begin a:=0.5;
  Pmmm;
  initvect(ope[1].tau, 0,0,0);
  initvect(ope[2].tau, a,a,a);
  initvect(ope[3].tau, 0,a,0);
  initvect(ope[4].tau, a,0,a);
  initvect(ope[5].tau, 0,0,0);
  initvect(ope[6].tau, a,a,a);
  initvect(ope[7].tau, 0,a,0);
  initvect(ope[8].tau, a,0,a);
 end;

 procedure Pnam {D_2h^16 v dr. ust.; primer - polietilen}; var a:real;
 begin a:=0.5;
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
  n_oper:=8;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,1,0, 0,0,1); initvect(ope[2].tau, a,a,a);
  initmatr(ope[3].a, 1,0,0, 0,-1,0, 0,0,1); initvect(ope[3].tau, a,a,0);
  initmatr(ope[4].a, 1,0,0, 0,1,0, 0,0,-1); initvect(ope[4].tau, 0,0,a);
  initmatr(ope[5].a, -1,0,0, 0,-1,0, 0,0,-1); initvect(ope[5].tau, 0,0,0);
  initmatr(ope[6].a, 1,0,0, 0,-1,0, 0,0,-1); initvect(ope[6].tau, a,a,a);
  initmatr(ope[7].a, -1,0,0, 0,1,0, 0,0,-1); initvect(ope[7].tau, a,a,0);
  initmatr(ope[8].a, -1,0,0, 0,-1,0, 0,0,1); initvect(ope[8].tau, 0,0,a);
 end;

 procedure Fddd {D_2h^24}; var a:real; {primer - Na2SeO4}
 begin a:=0.25;
  Pmmm;
  {nachalo v 222}
  initvect(ope[1].tau, 0,0,0);
  initvect(ope[2].tau, 0,0,0);
  initvect(ope[3].tau, 0,0,0);
  initvect(ope[4].tau, 0,0,0);
  initvect(ope[5].tau, a,a,a);
  initvect(ope[6].tau, a,a,a);
  initvect(ope[7].tau, a,a,a);
  initvect(ope[8].tau, a,a,a);
  n_centrir:=4;
  initvect(centrir[1], 0,0,0);
  initvect(centrir[2], 0,1/2,1/2);
  initvect(centrir[3], 1/2,0,1/2);
  initvect(centrir[4], 1/2,1/2,0);
 end;

 procedure Fddd_i {D_2h^24}; var a:real; {primer - Na2SeO4}
 begin a:=0.25;
  Pmmm;
  {nachalo v 1_}
  initvect(ope[1].tau, 0,0,0);
  initvect(ope[2].tau, 0,a,a);
  initvect(ope[3].tau, a,0,a);
  initvect(ope[4].tau, a,a,0);
  initvect(ope[5].tau, 0,0,0);
  initvect(ope[6].tau, 0,a,a);
  initvect(ope[7].tau, a,0,a);
  initvect(ope[8].tau, a,a,0);
  n_centrir:=4;
  initvect(centrir[1], 0,0,0);
  initvect(centrir[2], 0,1/2,1/2);
  initvect(centrir[3], 1/2,0,1/2);
  initvect(centrir[4], 1/2,1/2,0);
 end;

{ -------- tetrag. -------- }

 procedure I4_1a; {C4h^6 = I4_1/a; primer - SrMoO4 (tip sheelita)} var c4,c2:oper;
 begin
  n_oper:=8;
  initmatr(c4.a, 0,-1,0, 1,0,0, 0,0,-1); initvect(c4.tau,0,0,0);
  initmatr(c2.a, 1,0,0, 0,1,0, 0,0,-1); initvect(c2.tau,0,1/2,1/4);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 4 do proizv(ope[i],ope[i-1],c4);
  for i:=5 to 8 do proizv(ope[i],c2,ope[i-4]);
  n_centrir:=2;
  initvect(centrir[1], 0,0,0); initvect(centrir[2], 1/2,1/2,1/2);
 end;

 procedure P4_12_12; {D4^4; primery - CuCl*3tiomoch, H2O2} var c4,c2:oper;
 begin
  n_oper:=8;
  initmatr(c4.a, 0,-1,0, 1,0,0, 0,0,1); initvect(c4.tau,1/2,1/2,1/4);
  initmatr(c2.a, 0,1,0, 1,0,0, 0,0,-1); initvect(c2.tau,0,0,0);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 4 do proizv(ope[i],ope[i-1],c4);
  for i:=5 to 8 do proizv(ope[i],c2,ope[i-4]);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure P4_1_2_1; {D4^4 = P4_1_2_1 = P4_12_12}
 begin P4_12_12; end;

 procedure I4_2d; {D2d^12; primer: KH2PO4}
 begin
  n_oper:=8;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, -1,0,0, 0,-1,0, 0,0,1); initvect(ope[2].tau, 0,0,0);
  initmatr(ope[3].a, 0,-1,0, 1,0,0, 0,0,-1); initvect(ope[3].tau, 0,0,0);
  initmatr(ope[4].a, 0,1,0, -1,0,0, 0,0,-1); initvect(ope[4].tau, 0,0,0);
  initmatr(ope[5].a, -1,0,0, 0,1,0, 0,0,-1); initvect(ope[5].tau, 1/2,0,1/4);
  initmatr(ope[6].a, 1,0,0, 0,-1,0, 0,0,-1); initvect(ope[6].tau, 1/2,0,1/4);
  initmatr(ope[7].a, 0,1,0, 1,0,0, 0,0,1); initvect(ope[7].tau, 1/2,0,1/4);
  initmatr(ope[8].a, 0,-1,0, -1,0,0, 0,0,1); initvect(ope[8].tau, 1/2,0,1/4);
  n_centrir:=2;
  initvect(centrir[1], 0,0,0);
  initvect(centrir[2], 1/2,1/2,1/2);
 end;

{ -------- geksag. -------- }
(*
  Geksag. i trig. gruppy:
  Predp.: v simvolakh vida P3m1 i P31m posle P3 1-j simvol sootv.
os`am C2 po transl. i/ili m perp. etim C2 i, t.o., napr. mezhdu transl.,
a 2-j simvol - C2 mezhdu transl., m po transl.

  V geksag. ustanovke:

        Y
         \
          .-----2-.
         3-\-----\-4              1 - iskhodn. - x,y
        / \ \   / \ \             2 - C6       - x-y,x
       /---\-\-/---\-1            3 - C3       - -y,x-y
   ---.-------.-----\-.--- X      4 - m        - x,x-y
       \-----/-\---- 5            5 - m'       - x-y,-y
        \   /   \   /
         \-/-----\-/
          .-------.
                   \

  Eto mozhno ispol`z. kak zagotovki dl`a porozhd. matrits el-tov simm.;
pri etom znak pri z m.b. '+' (C6, C3, m) ili '-' (S6, C2 perp. C6).

  V romboedr. ustanovke:

          Y       -Z
        *  \     / *
            \   /          S6: x->-z i t.d. => 0-10 00-1 -100
             \ /     *     C3: x->y, y->z, z->x => 001 100 010
     -X ------.------ X    m po x: y<->z => 100 001 010
             / \     *     C2 mezhdu x i -z: x->-z, y->-y, z->-x =>
            /   \                               00-1 0-10 -100
           /     \
          Z      -Y

  Pokhozhe, drugikh porozhdajushchikh el-tov ne potrebuetsa.
  Esli potrebuetsa m mezhdu x i -z: eto aa0 a0a 0aa, gde a=1/2.
*)

 procedure P3_2; {P3_1=C3^2, P3_2=C3^3} {primer - gamma-glitsin}
  var c3,c2:oper; i:integer;
 begin
  n_oper:=3;
  initmatr(c3.a, 0,-1,0, 1,-1,0, 0,0,1); initvect(c3.tau,0,0,2/3);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 3 do proizv(ope[i],ope[i-1],c3);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure P3_12; {D3^4=P3_121, D3^6=P3_221} {primery: kinovar`; kvarts}
 {imejushchees`a opis. SiO2 rassch. imenno na c3.tau=2/3 !!!}
  var c3,c2:oper; i:integer;
 begin
  n_oper:=6;
  initmatr(c3.a, 0,-1,0, 1,-1,0, 0,0,1); initvect(c3.tau,0,0,2/3);
  initmatr(c2.a, 1,-1,0, 0,-1,0, 0,0,-1); initvect(c2.tau,0,0,0);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 3 do proizv(ope[i],ope[i-1],c3);
  for i:=4 to 6 do proizv(ope[i],c2,ope[i-3]);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

(*
 procedure P3_12; {al`ternativn. opis.; snova c3.tau=2/3 !!!}
 begin
  n_oper:=6;
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau, 0,0,0);
  initmatr(ope[2].a, 0,-1,0, 1,-1,0, 0,0,1); initvect(ope[2].tau, 0,0,2/3);
  initmatr(ope[3].a, -1,1,0, -1,0,0, 0,0,1); initvect(ope[3].tau, 0,0,1/3);

  initmatr(ope[4].a, 1,-1,0, 0,-1,0, 0,0,-1); initvect(ope[4].tau, 0,0,0);
  initmatr(ope[5].a, 0,1,0, 1,0,0, 0,0,-1); initvect(ope[5].tau, 0,0,2/3);
  initmatr(ope[6].a, -1,0,0, -1,1,0, 0,0,-1); initvect(ope[6].tau, 0,0,1/3);
*)
(*

           Y
            \                             1 = x y
             ----5-------                 2 = -y x-y
           /  \          \                3 = -(x-y) -x
          2----\          \               4 = x-y -y
         / \    \--------- 1              5 = y x
        /   \    \          \             6 = -x -(x-y)
       .----\\--- 0----------.---- X
        \    \   /          /
         \    \ /          4
          6    /          /
           \  / \        /
              ---3------
*)
(*
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;
*)

{ -------- romboedr. -------- }
 {bazis - elem. transl. romboedra; vozm., imelo by smysl sdelat`
   al`ternativn. var-ty: elem. transl. - kak dl`a geksag. yach.,
   a romboedrichnost` - za schot tsentrirovannosti.
 }
 {pl-sti otrazh. mogut idti po pl-st`am, v k-rykh lezhat minim. transl.,
   a mogut - mezhdu nimi; risuem vid sverkhu i sm., vo chto perekh.
   vektury bazisa -> v 1-m sluch. C3=(001 100 010), vo 2-m = (aa0 a0a 0aa),
   gde a=1/2. Predp., chto 1-j sluch. sootv. P3m1, 2-j - P31m.
}

 procedure P3m1_h; {C3v^1} var s6,b:oper; u,c,s:real; i:integer;
 {v geksag. os`akh}
 begin
  n_oper:=6;
  initmatr(s6.a, 0,-1,0, 1,-1,0, 0,0,1); initvect(s6.tau,0,0,0);
  initmatr(b.a, 0,-1,0, -1,0,0, 0,0,1); initvect(b.tau,0.0,0.0,0.0);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 3 do proizv(ope[i],ope[i-1],s6);
  for i:=4 to 6 do proizv(ope[i],b,ope[i-3]);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure P3m1; {C3v^1} var s6,b:oper; u,c,s:real; i:integer;
 {v romboedr. os`akh; primer - NH4ClO3}
 begin
  n_oper:=6;
  initmatr(s6.a, 0,0,1, 1,0,0, 0,1,0); initvect(s6.tau,0,0,0);
  initmatr(b.a, 1,0,0, 0,0,1, 0,1,0); initvect(b.tau,0.0,0.0,0.0);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 3 do proizv(ope[i],ope[i-1],s6);
  for i:=4 to 6 do proizv(ope[i],b,ope[i-3]);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure P31m; {C3v^2} var s6,b:oper; u,c,s:real; i:integer; d:real;
 begin
  d:=0.5;
  n_oper:=6;
  initmatr(s6.a, d,d,0, d,0,d, 0,d,d); initvect(s6.tau,0,0,0);
  initmatr(b.a, 1,0,0, 0,0,1, 0,1,0); initvect(b.tau,0.0,0.0,0.0);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 3 do proizv(ope[i],ope[i-1],s6);
  for i:=4 to 6 do proizv(ope[i],b,ope[i-3]);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure R3_m; {D3d^5} var s6,b:oper; u,c,s:real; i:integer;
 {primer - CaCO3}
 begin
  n_oper:=12;
  initmatr(s6.a, 0,-1,0, 0,0,-1, -1,0,0); initvect(s6.tau,0,0,0);
  initmatr(b.a, 1,0,0, 0,0,1, 0,1,0); initvect(b.tau,0.0,0.0,0.0);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 6 do proizv(ope[i],ope[i-1],s6);
  for i:=7 to 12 do proizv(ope[i],b,ope[i-6]);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure R3_m_h; {D3d^5} var s6,b:oper; u,c,s:real; i:integer;
 {to zhe v geksag. ustanovke}
 begin
  n_oper:=12;
  initmatr(s6.a, 1,-1,0, 1,0,0, 0,0,-1); initvect(s6.tau,0,0,0);
  initmatr(b.a, 1,0,0, 1,-1,0, 0,0,1); initvect(b.tau,0.0,0.0,0.0);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 6 do proizv(ope[i],ope[i-1],s6);
  for i:=7 to 12 do proizv(ope[i],b,ope[i-6]);
  n_centrir:=3;
  initvect(centrir[1], 0,0,0);
  initvect(centrir[2], 2/3,1/3,1/3);
  initvect(centrir[3], 1/3,2/3,2/3);
 end;

 procedure R3_c; {D3d^6} var s6,b:oper; u,c,s:real; i:integer;
 {primer - Al2O3 (proverit`, ne R3c=C3v^6 li !!!)}
 begin
  n_oper:=12;
  initmatr(s6.a, 0,-1,0, 0,0,-1, -1,0,0); initvect(s6.tau,0,0,0);
  initmatr(b.a, 1,0,0, 0,0,1, 0,1,0); initvect(b.tau,0.5,0.5,0.5);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 6 do proizv(ope[i],ope[i-1],s6);
  for i:=7 to 12 do proizv(ope[i],b,ope[i-6]);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 {-----}

 procedure P6_3; {C6^6} var s6,b:oper; u,c,s:real; i:integer;
 begin
  n_oper:=6;
  initmatr(s6.a, 1,-1,0, 1,0,0, 0,0,1); initvect(s6.tau,0,0,1/2);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 6 do proizv(ope[i],ope[i-1],s6);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 {-----}

 procedure P3_m1; {D3d^3} var s6,b:oper; u,c,s:real; i:integer;
 {geksag. vybor osej}
 {primer - PbI2 2H}
 begin
  n_oper:=12;
  initmatr(s6.a, 1,-1,0, 1,0,0, 0,0,-1); initvect(s6.tau,0,0,0);
  initmatr(b.a, 0,-1,0, -1,0,0, 0,0,1); initvect(b.tau,0.0,0.0,0.0);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 6 do proizv(ope[i],ope[i-1],s6);
  for i:=7 to 12 do proizv(ope[i],b,ope[i-3]);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

{-----}

 procedure P6_3mc; {C6v^4} var s6,b:oper; u,c,s:real; i:integer;
 begin
  n_oper:=12;
  initmatr(s6.a, 1,-1,0, 1,0,0, 0,0,1); initvect(s6.tau,0,0,1/2);
  initmatr(b.a, 0,-1,0, -1,0,0, 0,0,1); initvect(b.tau,0,0,0);
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1); initvect(ope[1].tau,0,0,0);
  for i:=2 to 6 do proizv(ope[i],ope[i-1],s6);
  for i:=7 to 12 do proizv(ope[i],b,ope[i-6]);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;


{-------- kub. --------}
{------ T ------}

 procedure point_23 {T};
  var i:integer;
 begin
  n_oper:=12;
  {E}
  initmatr(ope[1].a, 1,0,0, 0,1,0, 0,0,1);
  { 3 C4^2 }
  initmatr(ope[2].a,  1,0,0, 0,-1,0, 0,0,-1);
  initmatr(ope[3].a, -1,0,0, 0,1,0, 0,0,-1);
  initmatr(ope[4].a, -1,0,0, 0,-1,0, 0,0,1);
  { 8 C3 }
  initmatr(ope[5].a, 0,1,0, 0,0,1, 1,0,0);
  initmatr(ope[6].a, 0,1,0, 0,0,-1, -1,0,0);
  initmatr(ope[7].a, 0,-1,0, 0,0,1, -1,0,0);
  initmatr(ope[8].a, 0,-1,0, 0,0,-1, 1,0,0);
  initmatr(ope[9].a, 0,0,1, 1,0,0, 0,1,0);
  initmatr(ope[10].a, 0,0,1, -1,0,0, 0,-1,0);
  initmatr(ope[11].a, 0,0,-1, 1,0,0, 0,-1,0);
  initmatr(ope[12].a, 0,0,-1, -1,0,0, 0,1,0);
  for i:=1 to 12 do initvect(ope[i].tau,0,0,0);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure P2_13; {T^4} {primer - NaClO3}
 begin
  point_23;
  n_oper:=12;
  {E}
  initvect(ope[1].tau,0,0,0);
  { 3 C4^2 }
  initvect(ope[2].tau,1/2,1/2,0);
  initvect(ope[3].tau,0,1/2,1/2);
  initvect(ope[4].tau,1/2,0,1/2);
  { 8 C3 }
  initvect(ope[5].tau,0,0,0);
  initvect(ope[6].tau,1/2,1/2,0);
  initvect(ope[7].tau,0,1/2,1/2);
  initvect(ope[8].tau,1/2,0,1/2);
  initvect(ope[9].tau,0,0,0);
  initvect(ope[10].tau,1/2,1/2,0);
  initvect(ope[11].tau,0,1/2,1/2);
  initvect(ope[12].tau,1/2,0,1/2);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

{------ Th ------}

 procedure point_m3 {Th};
  var b:oper; i:integer;
 begin
  point_23;
  initmatr(b.a, -1,0,0, 0,-1,0, 0,0,-1); {i}
  initvect(b.tau,0.0,0.0,0.0);
  n_oper:=24;
  for i:=13 to 24 do proizv(ope[i],b,ope[i-12]);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

{------ O ------}

 procedure point_432 {O};
  var b:oper; i:integer;
 begin
  point_23;
  initmatr(b.a, -1,0,0, 0,0,1, 0,1,0); {1 iz 6 C2}
  initvect(b.tau,0.0,0.0,0.0);
  n_oper:=24;
  for i:=13 to 24 do proizv(ope[i],b,ope[i-12]);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

{------ Td ------}

 procedure point_4_3m {Td};
  var b:oper; i:integer;
 begin
  point_23;
  initmatr(b.a, 1,0,0, 0,0,-1, 0,-1,0); {sigma d}
  initvect(b.tau,0.0,0.0,0.0);
  n_oper:=24;
  for i:=13 to 24 do proizv(ope[i],b,ope[i-12]);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

{------ Oh ------}

 procedure point_m3m {Oh};
  var b:oper; i:integer;
 begin
  point_432;
  initmatr(b.a, -1,0,0, 0,-1,0, 0,0,-1); {i}
  initvect(b.tau,0.0,0.0,0.0);
  n_oper:=48;
  for i:=25 to 48 do proizv(ope[i],b,ope[i-24]);
  n_centrir:=1;
  initvect(centrir[1], 0,0,0);
 end;

 procedure Pm3n; var i:integer;
 {Oh^3; primer - gidraty-klatraty X*5,75H2O s a~12A bez uchota H}
 begin
  point_m3m;
  for i:=1 to 12 do initvect(ope[i].tau,0,0,0); {E,3C4,8C3}
  for i:=13 to 24 do initvect(ope[i].tau,1/2,1/2,1/2); {6C2,6C4}
  for i:=25 to 36 do initvect(ope[i].tau,0,0,0); {i, 3sigmah,8S6}
  for i:=37 to 48 do initvect(ope[i].tau,1/2,1/2,1/2); {6sigmad,6S4}
 end;

 procedure Fd3m; var i:integer; b:oper;
 {Oh^7; primer - gidraty-klatraty X*17H2O s a~17.2A bez uchota H;
   primech.: tam dl`a dostizh. izvestnykh krat-stej pozitsij prishlos`
   iz vsekh koord. vychest` 1/8 !
 }
 begin
  point_23;
  initvect(ope[1].tau,0,0,0);
  initvect(ope[2].tau,0,1/4,1/4);
  initvect(ope[3].tau,1/4,0,1/4);
  initvect(ope[4].tau,1/4,1/4,0);
  initvect(ope[5].tau,0,0,0);
  initvect(ope[6].tau,0,1/4,1/4);
  initvect(ope[7].tau,1/4,0,1/4);
  initvect(ope[8].tau,1/4,1/4,0);
  initvect(ope[9].tau,0,0,0);
  initvect(ope[10].tau,0,1/4,1/4);
  initvect(ope[11].tau,1/4,0,1/4);
  initvect(ope[12].tau,1/4,1/4,0);
  initmatr(b.a, 1,0,0, 0,0,1, 0,1,0); {sigma_d; C2= -x,z,y treb. 0 3/4 3/4}
  initvect(b.tau,0,0,0);
  for i:=13 to 24 do proizv(ope[i],b,ope[i-12]);
  initmatr(b.a, -1,0,0, 0,-1,0, 0,0,-1); {i}
  initvect(b.tau,0,0,0);
  for i:=25 to 48 do proizv(ope[i],b,ope[i-24]);
  n_oper:=48;
  n_centrir:=4;
  initvect(centrir[1], 0,0,0);
  initvect(centrir[2], 0,1/2,1/2);
  initvect(centrir[3], 1/2,0,1/2);
  initvect(centrir[4], 1/2,1/2,0);
 end;
